        name    tadxt   ;    (Time & Date)
	page	60,132
        title   'TADXT.COM --- copy DOS time & date to hardware'
;
; TADXT.COM calls the DOS system Get Time & Get Date functions
;
; The binary values returned by	the DOS	function are
; converted to packed BCD required by the hardware clock
;
; Note that the port values used here are valid for many XT clones
;
port1   equ     0240h           ;Common value for CMOS clock
port2   equ     0340h           ;Alternate value for CMOS clock
;
cseg	segment	para	public	'CODE'
;
	org	100h		;COM files always have
				;ORIGIN	of 100H.
;
	assume	cs:cseg,ds:cseg,es:cseg,ss:cseg
;
setclk	proc	near

        jmp     init

gdmess: db      "DOS Time & Date copied to XT CMOS Clock",0dh,0ah,'$'
flmess: db      "XT CMOS Clock not found.",0dh,0ah,'$'

nten    db      10              ;constant ten for BCD
prtadr  dw      0               ;keep address of CMOS clock

init:   mov     word ptr [prtadr],offset port1
        mov     dx,offset 1
        call    inport          ;try first port value
        cmp     al,99h
        jbe     setime

        mov     word ptr [prtadr],offset port2
        mov     dx,offset 1
        call    inport          ;try second port value
        cmp     al,99h
        jbe     setime

fail:   mov     dx, offset flmess
        mov     ah,9
        int     21h             ;neither value works
        mov     ax, 4c01h       ;return code 1
        int     21h

setime: mov     ah,02ch         ;Get system time (DOS)
	int	21h
	xchg	bx,dx		;save register with seconds
        mov     dx,1            ;port address  (100ths)
	mov	al,bl		;get register with 100ths
	call	outport		;translate and output
        inc     dx              ;port address (second)
        mov     al,bh           ;get register with second
        call    outpt1          ;translate and output
        inc     dx              ;port address (minute)
        mov     al,cl           ;get register with minute
        call    outpt1          ;translate and output
        inc     dx              ;port address (hour)
        mov     al,ch           ;get register with hour
        call    outpt1          ;translate and output
        mov     ah,02ah         ;Get system date (DOS)
        int     21h
        xchg    bx,dx           ;save register
        mov     dx,6            ;port address (day)
        mov     al,bl           ;get register with day
        call    outport         ;translate and output
        inc     dx              ;port address (month)
        mov     al,bh           ;get register with month
        call    outpt1          ;translate and output
        inc     dx              ;
        inc     dx              ;port address (year)
        mov     ax,cx           ;get register with year
        cmp     ax,2000         ;3rd millenium?
        jc      second
        sub     ax,100
second: sub     ax,1900         ;reduce to two digits
        call    outpt1          ;translate and output
        mov     dx, offset gdmess
        mov     ah,9
        int     21h
        mov     ax,4c00h        ;return code 0
	int	21h		;terminate program
setclk	endp

; Convert binary value to packed BCD and output to port

outport	proc	near
        add     dx, word ptr [prtadr]
outpt1: xor     ah,ah           ;have full port address in dx
        div     nten            ;divide by 10
	shl	al,1		;convert quotient
	shl	al,1		;to tens digit.
	shl	al,1		;to make packed	BCD,
	shl	al,1
	or	al,ah		;add in	the remainder
	cli			;be defensive
        out     dx,al           ;write to the CMOS Clock
	sti			;restore interrupts
	ret
outport	endp

; Get a byte from the port defined by prtadr

inport  proc    near
        add     dx, word ptr [prtadr]
	cli			;be defensive
        in      al,dx           ;read from the CMOS clock
	sti			;restore interrupts
	ret
inport  endp

cseg	ends

	end	setclk
